using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace RobotCtrl
{
    public abstract class RadarSensorBase
    {
        public abstract double Distance { get; }

        public RadarSensorBase()
        {
        }
    }

    public sealed class RadarSensor : RadarSensorBase  
    {
        //HALLO MARTIN, hast du das so gemacht?
        //Hallo Thomas, ja, hab ich :-D

        private readonly PositionInfo robotPos; // centerPosition of the Robot
        private readonly PositionInfo offset;

		public override double Distance { get { return GetFreeSpace(); } }

        public RadarSensor(PositionInfo center, PositionInfo offset)
        {
            this.robotPos = center;
            this.offset = offset;
        }                                   

        public double GetFreeSpace()
        {
            double phi = robotPos.Angle / 180.0 * Math.PI;
            PositionInfo radarPos = new PositionInfo(
                robotPos.X + offset.X * Math.Cos(phi) - offset.Y * Math.Sin(phi),
                robotPos.Y + offset.X * Math.Sin(phi) + offset.Y * Math.Cos(phi),
                (robotPos.Angle + offset.Angle) % 360);

            var minFreeSpace = World.Obstacles.Select(o => o.GetFreeSpace(radarPos)).Min();
            return minFreeSpace;
        }
    }

}
