﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace Test_Console_CE
{
    public partial class ChartForm : Form
    {
        private Chart.ChartView chart;
        private Random rand = new Random();
        private Thread thread;

        public ChartForm()
        {
            InitializeComponent();

            chart = new Chart.ChartView();
            chart.Location = new Point(10, 10);
            chart.Size = new Size(500, 500);
            this.Size = new Size(600, 600);
            this.Controls.Add(chart);

            thread = new Thread(simulation);
            thread.Start();

        }



        private void simulation()
        {
            int capacity = 100;
            chart.Capacity = capacity;
            chart.Autoscale = true;

            while (true)
            {
                chart.Enqueue(/*rand.NextDouble()*/ (MousePosition.X + MousePosition.Y)/10);
                Thread.Sleep(100);
            }
        }

        private void ChartForm_Closing(object sender, CancelEventArgs e)
        {
            if (thread != null)
            {
                thread.Abort();
            }
        }
    }
}